package cn.com.tenlion.materialstore.service.materialtext;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.materialstore.pojo.dtos.materialtext.MaterialTextDTO;
import cn.com.tenlion.materialstore.pojo.vos.materialtext.MaterialTextVO;
import cn.com.tenlion.materialstore.pojo.bos.materialtext.MaterialTextBO;
import cn.com.tenlion.materialstore.pojo.pos.materialtext.MaterialTextPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMaterialTextService
 * @Description: 文字素材
 * @Author: CodeFactory
 * @Date: 2021-05-28 11:06:15
 * @Version: 3.0
 **/
public interface IMaterialTextService {

    /**
     * 新增文字素材
     *
     * @param materialTextVO
     * @return
     */
    void save(MaterialTextVO materialTextVO);

    /**
     * 新增文字素材
     *
     * @param token
     * @param materialTextVO
     * @return
     */
    void save(String token, MaterialTextVO materialTextVO);

    /**
     * 新增文字素材
     *
     * @param materialTextVO
     * @return materialTextId
     */
    String saveReturnId(MaterialTextVO materialTextVO);

    /**
     * 新增文字素材
     *
     * @param token
     * @param materialTextVO
     * @return materialTextId
     */
    String saveReturnId(String token, MaterialTextVO materialTextVO);

    /**
     * 删除文字素材
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除文字素材
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除文字素材（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改文字素材
     *
     * @param materialTextId
     * @param materialTextVO
     * @return
     */
    void update(String materialTextId, MaterialTextVO materialTextVO);

    /**
     * 修改文字素材
     *
     * @param token
     * @param materialTextId
     * @param materialTextVO
     * @return
     */
    void update(String token, String materialTextId, MaterialTextVO materialTextVO);

    /**
     * 文字素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialTextDTO get(Map<String, Object> params);

    /**
     * 文字素材详情
     *
     * @param materialTextId
     * @return
     */
    MaterialTextDTO get(String materialTextId);

    /**
     * 文字素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialTextBO getBO(Map<String, Object> params);

    /**
     * 文字素材详情
     *
     * @param materialTextId
     * @return
     */
    MaterialTextBO getBO(String materialTextId);

    /**
     * 文字素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialTextPO getPO(Map<String, Object> params);

    /**
     * 文字素材详情
     *
     * @param materialTextId
     * @return
     */
    MaterialTextPO getPO(String materialTextId);

    /**
     * 文字素材列表
     *
     * @param params
     * @return
     */
    List<MaterialTextDTO> list(Map<String, Object> params);

    /**
     * 文字素材列表
     *
     * @param params
     * @return
     */
    List<MaterialTextBO> listBO(Map<String, Object> params);

    /**
     * 文字素材列表
     *
     * @param params
     * @return
     */
    List<MaterialTextPO> listPO(Map<String, Object> params);

    /**
     * 文字素材分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MaterialTextDTO>> listPage(ListPage page);

    /**
     * 文字素材统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    List<MaterialTextDTO> getByMaterialId(String materialId);

    void removeByMaterialId(String materialId);

    void updateCheck(String id);
}